package com.base.filerecoveryrecyclebin.ads.max

import android.app.Activity
import android.content.Context
import com.applovin.mediation.MaxAd
import com.applovin.mediation.MaxAdListener
import com.applovin.mediation.MaxError
import com.applovin.mediation.ads.MaxAppOpenAd
import com.base.datarecovery.ads.max.AdMaxEvent
import com.base.filerecoveryrecyclebin.ads.AdDisplayUtils
import com.base.filerecoveryrecyclebin.ads.AdmobCommonUtils
import com.base.filerecoveryrecyclebin.help.ConfigHelper
import com.base.filerecoveryrecyclebin.utils.EventUtils
import com.base.filerecoveryrecyclebin.utils.LogEx
import org.json.JSONObject

object AdMaxOpenUtils {
    private val TAG = "com.base.filerecoveryrecyclebin.ads.max.AdMaxOpenUtils"
    private var appOpenAd: MaxAppOpenAd? = null
    private var openLoadTime = Long.MAX_VALUE
    private var onHidden: (() -> Unit)? = null
    private var loadingListener: (() -> Unit)? = null

    private fun setListener(context: Context) {
        if (appOpenAd == null) {
            appOpenAd = MaxAppOpenAd(ConfigHelper.openAdMaxId, context)

            appOpenAd?.setListener(object : MaxAdListener {
                override fun onAdLoaded(p0: MaxAd) {
                    LogEx.logDebug(TAG, "onAdLoaded")
                    openLoadTime = System.currentTimeMillis()
                    loadingListener?.invoke()
                    AdMaxEvent.pullAd(p0, "openAd")
                }

                override fun onAdLoadFailed(p0: String, p1: MaxError) {
                    LogEx.logDebug(TAG, "onAdLoadFailed:" + p1.message.toString())
                    onHidden?.invoke()
                    AdDisplayUtils.getInstance().incrementAdRequestFailCount()
                    AdMaxEvent.pullAd(null, "openAd")
                }


                override fun onAdDisplayed(p0: MaxAd) {
                    AdDisplayUtils.getInstance().incrementAdDisplayCount()
                    AdMaxEvent.showAd(p0, "openAd")
                }

                override fun onAdHidden(p0: MaxAd) {
                    onHidden?.invoke()
                    appOpenAd?.loadAd()
                    loadingListener = null
                }

                override fun onAdClicked(p0: MaxAd) {
                    AdDisplayUtils.getInstance().incrementAdClickCount()
//                    com.base.datarecovery.ads.max.AdMaxEvent.clickAd(appOpenAd, "openAd")
                    AdmobCommonUtils.isMultiClick(appOpenAd)
                    AdMaxEvent.clickAd(p0, "openAd")
                }


                override fun onAdDisplayFailed(p0: MaxAd, p1: MaxError) {
                    LogEx.logDebug(TAG, "onAdDisplayFailed")
                    onHidden?.invoke()
                    appOpenAd?.loadAd()
                    val obj = JSONObject()
                    obj.put("reason", p1.message)
                    obj.put("ad_unit", "openAd")
                    EventUtils.event("ad_show_error", ext = obj)
                }
            })

            appOpenAd?.setRevenueListener { ad ->

            }
        }
    }

    fun showAppOpenAd(activity: Activity, loaded: (() -> Unit)? = null, onHidden: (() -> Unit)? = null) {

        setListener(activity)

        if (activity.isFinishing || activity.isDestroyed) {
            return
        }

        if (!AdDisplayUtils.getInstance().shouldShowAd()) {
            LogEx.logDebug(TAG, "!shouldShowAd")
            onHidden?.invoke()
            return
        }

        if (System.currentTimeMillis() - openLoadTime > 1000 * 60 * 60) {
            LogEx.logDebug(TAG, "openLoadTime > ")
            onHidden?.invoke()
            val obj2 = JSONObject()
            obj2.put("ad_unit", "openAd")
            EventUtils.event("ad_expire", ext = obj2)
            appOpenAd?.loadAd()
        }

        if (!AdMaxInit.isAdMaxInit.get()) {
            onHidden?.invoke()
            return
        }


        LogEx.logDebug(TAG, "showAppOpenAd continue")

        AdMaxOpenUtils.onHidden = onHidden

        if (appOpenAd?.isReady == true) {
            LogEx.logDebug(TAG, "isReady=false")
            appOpenAd?.setRevenueListener(AdMaxEvent.EventOnPaidEventListener())
            appOpenAd?.showAd()
        } else {
            appOpenAd?.loadAd()
            loadingListener = {
                LogEx.logDebug(TAG, "loadingListener callback")
                loaded?.invoke()
                val obj1 = JSONObject()
                obj1.put("ad_unit", "openAd")
                EventUtils.event("ad_prepare_show", ext = obj1)
                appOpenAd?.showAd()
                loadingListener = null
            }
        }
    }

    fun loadAppOpenAd(activity: Activity) {
        setListener(activity)

        if (!AdDisplayUtils.getInstance().shouldShowAd()) {
            LogEx.logDebug(TAG, "!shouldShowAd")
            return
        }

        if (AdMaxInit.isAdMaxInit.get()) {
            LogEx.logDebug(TAG, "appOpenAd load")
            appOpenAd?.loadAd()
        }
    }

}

